from mpf.system.mode import Mode
from mpf.system.tasks import DelayManager
from mpf.system.timing import Timing

# Gate Keeper Multiball
# 
# This is a super-secret multiball mode which can only be accessed by knowing how 
# to select your gift from the mystery award process. This 2-ball multiball basically
# boils down to hitting the gate in front of Oogie Boogie's lair for 250,000 points each hit. 
# The 9th hit lowers the gate and if you get the ball back into Oogie Boogie's lair
# you'll get an extra ball, after which the gate comes up and stays up and simply continues to 
# award 250,000 points. The trick is there's no ball save on this multiball,
# although you do get one for 15 seconds when the multiball ends, thus you can't double-drain out of it. 
# If multiple targets are hit at once, it still only counts as a single
# gate hit, as there's an extremely short delay after any target on the gate is hit where the 
# targets won't register a second time.

class Gate_Keeper(Mode):

    def mode_init(self):
        print 'Gate_Keeper mode_init'

    def mode_start(self, **kwargs):
        print 'Gate_Keeper mode_start'

    def mode_stop(self, **kwargs):
        print 'Gate_Keeper mode_stop'


